local E, L, V, P, G, _ = unpack(ElvUI) --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local ElvUF = ElvUI.oUF
local UF = E:GetModule('UnitFrames');

-- Cache global variables
-- WoW API / Variables
local strfind, strmatch, strlower, utf8lower, utf8sub, utf8len = strfind, strmatch, strlower, string.utf8lower, string.utf8sub, string.utf8len
local gmatch, gsub, format = gmatch, gsub, format
local abs, ceil = math.abs, ceil
local UnitName = UnitName
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitIsAFK = UnitIsAFK
local UnitIsConnected = UnitIsConnected
local UnitIsDead = UnitIsDead
local UnitIsGhost = UnitIsGhost
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitGetIncomingHeals = UnitGetIncomingHeals
local UnitGetTotalAbsorbs = UnitGetTotalAbsorbs
local UnitClass = UnitClass
local UnitIsPlayer = UnitIsPlayer
local strupper = strupper
local GetSpecialization = GetSpecialization
local GetSpecializationInfo = GetSpecializationInfo
local SPELL_POWER_MANA = Enum.PowerType.Mana
local UnitGroupRolesAssigned = UnitGroupRolesAssigned

-- [[ Tag Info ]]
E:AddTagInfo("gnuihmana", "|cffc41f3bGennUI|r", "Mana percent for Healers, hide when full", 3)

-- [[ Tags ]]
ElvUF.Tags.Events['gnuihmana'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER'
ElvUF.Tags.Methods['gnuihmana'] = function(unit)
	local cur = UnitPower(unit, SPELL_POWER_MANA)
	local max = UnitPowerMax(unit, SPELL_POWER_MANA)
	local CurPercent = (cur/max)*100
		local CurrSpec = GetSpecialization()
		local _, CurrSpecName = GetSpecializationInfo(CurrSpec)
		if ( CurrSpecName == 'Restoration' or CurrSpecName == 'Holy' or CurrSpecName == 'Discipline' ) and cur ~= max then
		return format("%.0f%%", CurPercent)
		end
end

--[[ElvUF.Tags.Events['gnuihmana'] = 'UNIT_POWER_FREQUENT UNIT_MAXPOWER'
ElvUF.Tags.Methods['gnuihmana'] = function(unit)
	local cur = UnitPower(unit, SPELL_POWER_MANA)
	local max = UnitPowerMax(unit, SPELL_POWER_MANA)
	local CurPercent = (cur/max)*100
	local CurRole = UnitGroupRolesAssigned(unit)
	
	if CurRole == 'HEALER' and cur ~= max then
		return format("%.0f%%", CurPercent)
	elseif CurRole == 'NONE' and cur ~= max then
		local CurrSpec = GetSpecialization()
		local _, CurrSpecName = GetSpecializationInfo(CurrSpec)
		if ( CurrSpecName == 'Restoration' or CurrSpecName == 'Holy' or CurrSpecName == 'Discipline' or CurrSpecName == 'Mistweaver' ) then
		return format("%.0f%%", CurPercent)
		end
	else
		return nil
	end
end]]